<?php
/* Extensions autorisées pour les séquences */
$extensions = array("JPG", "JPEG", "WEBP", "BMP", "JFIF", "PNG", "GIF", "SVG", "TXT", "ODT", "ODS", "ODP", "PDF", "PPT", "PPTX", "DOC", "DOCX", "CSV", "XLS", "XLSX", "ZIP", "7Z");

// Tableau associatif pour convertir les jours de la semaine en nombres de jours
$daysOfWeek = array(
    'mon' => 1,
    'tue' => 2,
    'wed' => 3,
    'thu' => 4,
    'fri' => 5,
    'sat' => 6,
    'sun' => 7
);

$etab_lieu = @mysqli_query($bdd, "SELECT * FROM " . $prefix . "_etab ORDER BY etab_id DESC LIMIT 1");
if ($etab_lieu && mysqli_num_rows($etab_lieu) > 0) {
    $etab_i = mysqli_fetch_array($etab_lieu);
    $_SESSION['lieu_nom']= $etab_i['lieu_nom'];
    $genexp = explode(";", GENRES[$etab_i['lieu_genre']]);
    $_SESSION['lieu_genre1'] = $genexp[0];
    $_SESSION['lieu_genre2'] = $genexp[1];
}
else {
    $_SESSION['lieu_nom']= 'CDI';
    $_SESSION['lieu_genre1'] = 'du';
    $_SESSION['lieu_genre2'] = 'au';
}
function replacePlaceholdersToDb($text) {
    $mapping = array_flip(BARCODELEMS); // Inverser les clés et valeurs
    return strtr($text, $mapping);
}
function replacePlaceholdersFromDb($text) {
    return strtr($text, BARCODELEMS);
}

?>