<?php
$bdd = mysqli_connect($server,$user,$pwd,$base);
echo '<p style="text-align:center;font-size:1.4em;padding-top:5px;">'.INSTALLPARAM.'</p>'; flush(); ob_flush();
// Puis les paramétrages par défaut :
// -- Contenu de la table `preidlog_parametres`
$param_insert = "INSERT INTO `preidlog_parametres` (`param_id`, `param_nom`, `valeur`, `comments`) VALUES
(1, 'version_log', '8.31', 'Numéro de version courante du logiciel.'),
(2, 'version_bdd', '0.57', 'Version courante de la base de données.'),
(3, 'info_menu', '1', 'Option d''une infobulle sur les menus du logiciel.'), 
(4, 'savoirs', 'A1E0P0', 'Paramétrage des savoirs utilisés dans le module d''évaluation (A pour APD, E pour EMI, P pour PER - 0 pour désactivé, 1 pour activé).'),
(5, 'freq_seuilnbi', '0', 'Seuil maximal du nombre d''inscrits.'),
(6, 'freq_creneausuiv', '0', 'Passage anticipé à l''heure suivante pour les inscriptions.'),
(7, 'freq_multiinscrit', '0', 'Option d''inscription sur plusieurs créneaux.'),
(8, 'freq_inscritbutton', '0', 'Choix d''affichage des boutons de sortie et exclusion, ainsi que des retards, sur les droits non administrateurs.'),
(9, 'freq_seuilreaci', 'alert', 'Réaction lorsque le seuil maximal du nombre d''inscrits est atteint.'),
(10, 'freq_seuilnbr', '0', 'Seuil maximal du nombre de réservations.'),
(11, 'freq_seuilreacr', 'alert', 'Réaction lorsque le seuil maximal du nombre de réservations est atteint.'),
(12, 'freq_gestion_jourscren', '0', 'Option de gestion des fréquentation et des réservations, et quotas, par jour et par créneau.'),
(13, 'freq_ordreaff', 'div', 'Gestion de l''ordre d''affichage des inscriptions et réservations.'),
(14, 'freq_crendef', 'suivant', 'Choix du créneau de réservation par défaut.'),
(15, 'freq_resactiv', '0', 'Option de précision de l''activité lors de la réservation.'),
(16, 'freq_crprechoix', '0h', 'Autorisation ou non d''afficher les inscrits du créneau précédent, et emplacement de l''affichage.'), 
(17, 'freq_crenchoix', '0', 'Autorisation ou non du choix du créneau de réservation par l''usager.'), 
(18, 'freq_cienchoix', '0', 'Autorisation ou non du choix du créneau d''inscription.'), 
(19, 'freq_classe', '1', 'Possibilité d''inscrire par affichage de classe.'),
(20, 'freq_grappes', '0', 'Option de gestion des inscriptions par ensembles ou grappes d''élèves.'),
(21, 'freq_passages', '0', 'Option de gestion des simples passages en fréquentation.'),
(22, 'freq_inscritpronote', '0', 'Option d''inscription par copié/collé depuis Pronote.'),
(23, 'freq_appel', '1:1', 'Option de signalisation d''appel en consultation de la fréquentation.'),
(24, 'freq_seance_appel', '1', 'Option d''affichage du groupe concerné pour appel quand une séance est choisie.'),
(25, 'freq_chgtactiv', '0', 'Possibilité d''opérer des modifications dans le journal.'),
(26, 'freq_jhors', '0', 'Option de visualisation des heures d''inscriptions et de sorties dans le journal.'),
(27, 'freq_verractiv', '0', 'Option de verrouillage de l''activité par défaut.'), 
(28, 'freq_verrespace', '0', 'Option de verrouillage de l''espace par défaut.'),
(29, 'freq_vision_espaces_ins', '0', 'Option de visibilité du nombre d''inscrits par espace.'),
(30, 'freq_consultactiv', '1', 'Option de visualisation des activités en consultation.'), 
(31, 'freq_activ_obli', '0', 'Option d''obligation de renseigner une activité.'), 
(32, 'freq_statsniv', 'COL', 'Gestion des niveaux concernés dans l''établissement.'), 
(33, 'freq_statsniv_persoc', '', 'Gestion des regroupements personnalisés (caractères).'),
(34, 'freq_statsniv_person', '', 'Gestion des regroupements personnalisés (noms).'),
(35, 'freq_sigb', 'non', 'Option d''importation des retards de prêts depuis PMB ou BCDI.'),
(36, 'freq_retards_ordre', 'div', 'Ordre d''affichage des retards de prêts par défaut.'), 
(37, 'freq_retards_bip', '0', 'Choix d''un avertissement sonore lors des inscriptions au sujet des retards.'),
(38, 'freq_sigb_resa', 'non', 'Option d''importation de réservation de documents.'),
(39, 'freq_sigb_resaord', 'div', 'Gestion de l''ordre de présentation des réservations de documents.'),
(40, 'freq_sigb_resabip', '0', 'Choix d''un avertissement sonore lors des inscriptions au sujet des retards.'),
(41, 'freq_reseleve', '0', 'Option de réservation par chaque élève avec son code.'),
(42, 'freq_reseleve_mdp', '0', 'Mot de passe pour la réservation par chaque élève avec son code.'),
(43, 'freq_reseleve_mdpsel', '0', 'Sel pour le mot de passe générique de réservation.'),
(44, 'freq_reseleve_cgtmdp', '0', 'Autorisation de changement de mot de passe pour les usagers (0 par défaut).'),
(45, 'freq_reseleve_esp', '0', 'Option de réservation à distance par espaces.'),
(46, 'freq_reseleve_activ', '0', 'Option de précision de l''activité lors de la réservation à distance.'),
(47, 'freq_reseleve_creneau', '1', 'Gestion du créneau par défaut pour réservation à distance.'),
(48, 'freq_reseleve_dureemax', '0', 'Option de durée maximale pour la réservation à distance (en jours).'),
(49, 'freq_resblockevent', '0', 'Bloquage des réservations sur des événements.'),
(50, 'freq_resmodauth', 'code', 'Gestion du mode d''authentification spécifique des élèves.'),
(51, 'freq_resprintedt', '0', 'Affichage des EDT en réservation à distance.'),
(52, 'freq_resref_date', '0', 'Nombre de jours pour l''automatisation de période de refus de réservation.'),
(53, 'freqres_raison_opt', '0', 'Option de raison donnée à la réservation par élève.'),
(54, 'freqres_max', '0', 'Maximum de réservations par élève (0 : infini).'),
(55, 'freqres_max_origin', '0', 'Maximum applicable quel que soit l''origine de l''inscription.'),
(56, 'freqres_inscriptallday', '0', 'Possibilité d''opérer en préalable toutes les inscriptions des réservations de la journée.'),
(57, 'freq_connexion_infobulle', '0', 'Option d''infobulles sur la page de connexion.'),
(58, 'freq_excluopt', '0', 'Option de gestion des raisons et durées des exclusions.'),
(59, 'freq_excluopt_raisons', '0', 'Option de gestion des raisons des exclusions.'),
(60, 'freq_excluopt_signal', '0', 'Option de signalement des exclusions.'),
(61, 'freq_excluopt_signalduree', '10', 'Durée par défaut de signalement des exclusions.'),
(62, 'freq_excluopt_exc', '0', 'Option d''exclusions sur la durée.'),
(63, 'freq_excluopt_excduree', '10', 'Durée par défaut des exclusions.'),
(64, 'freq_excluopt_limit', '0', 'Option de gestion de limitations d''usages.'),
(65, 'freq_excluopt_limitduree', '10', 'Durée par défaut des limitations.'),
(66, 'freq_excluopt_activs', 'TOUTES', 'Activités concernées par une exclusion, par défaut.'),
(67, 'freq_notif_opt', '0', 'Option de notification de visites.'),
(68, 'freq_nbvisites_bip', '0', 'Option d''avertissement sonore en cas de passage d''un seuil de fréquentation.'),
(69, 'freq_notif_nb', '100', 'Nombre de visites pour la notification de visites.'),
(70, 'freq_birthday_img', '0', 'Option de visualisation d''anniversaire dans le module fréquentation.'),
(71, 'freq_birthday_bip', '0', 'Option d''avertissement sonore en cas d''anniversaire dans le module fréquentation.'),
(72, 'freq_api_nb', '0', 'Option d''enregistrement synchrone du nombre d''inscrits pour affichage'),
(73, 'barcodes_txt', 'IDLOG', 'Texte choisi pour le début du code élève.'),
(74, 'barcodes_int', '9', 'Nombre de chiffres pour le code élève.'),
(75, 'edt_coloration', 'niv', 'Choix du système de colorisation, entre niveaux et codes.'),
(76, 'edt_color_text', '0', 'Option de coloration du texte libre.'),
(77, 'edt_crencolors', '#EEEEEE#D0CCC2#7D7777#7D7777', 'Couleurs pour les créneaux libres, créneaux fermés avec ou sans texte, en-tête.'),
(78, 'edt_openmsg', '-', 'Message donné quand un créneau est libre dans l''emploi du temps.'),
(79, 'edt_brikverr', '1', 'Option de déverrouillage des briques des jours précédents.'),
(80, 'edt_duplicate', '0', 'Option de duplication des emplois du temps.'),
(81, 'edt_imgmode', 'spe', 'Option d''image générique ou d''images spécifiques.'),
(82, 'edt_imgnb', '20', 'Nombre maximal d''images spécifiques stockées.'),
(83, 'edt_msgopt', '0;1.8;#000', 'Option de message sous l''emploi du temps.'),
(84, 'edt_msg', '', 'Contenu du message sous l''emploi du temps.'),
(85, 'edt_titopt', '0;1.8;#000;0', 'Option de titre sur l''emploi du temps.'),
(86, 'edt_tit', '', 'Contenu du titre sur l''emploi du temps.'),
(87, 'edt_espmulti', '0-0000-00-00', 'Gestion d''un EDT pour chaque autre espace.'),
(88, 'eval_degres', '4', 'Choix du nombre de degrés d''évaluation, à trois ou quatre.'),
(89, 'eval_perso', 'niveau', 'Choix d''une évaluation par niveau ou globale sur la grille personnalisée.'),
(90, 'fuseau', 'Europe/Paris', 'Fuseau horaire pour la zone.'),
(91, 'colors_stats_array', '#FF9900#99FF00#CCFFFF#FF66FF#CC6600#FFFF33#99CC66#003399#9900FF#FF0033#CCCC00#66CC66#CCFFFF#333366#CC99CC#330033#FF6666#993300#33CC33#3399FF', 'Couleurs disponibles pour les graphiques, personnalisables.'),
(92, 'barcodes_default_modeleve', '1', 'Choix du modèle de code-barres pour les élèves par défaut.'),
(93, 'espaces_gestion', '0', 'Gestion de différents espaces.'),
(94, 'espaces_first', 'CDI', 'Nom de l''espace principal en cas de gestion de différents espaces.'),
(95, 'espaces_first_resamulti', '1', 'Option de réservation dans le premier espace, si plusieurs espaces.'),
(96, 'espaces_first_resadistmulti', '1', 'Option de réservation à distance dans le premier espace, si plusieurs espaces.'),
(97, 'mail_method', 'php', 'Choix de la méthode pour envoi de mails.'),
(98, 'language', 'fr', 'Option de choix de langue.'),
(99, 'charset', 'utf8mb4', 'Paramétrage du charset.')";
mysqli_query($bdd,$param_insert);

// Contenu de la table `preidlog_barcodes`
mysqli_query($bdd,"INSERT INTO preidlog_barcodes (nom, typusage, format, nbwidth, nbheight, type, margextg, margextd, margexth, margextb, margintg, margintd, marginth, margintb, textup, textspe, textupsize, fontsize) VALUES ('default', 'eleve', 'P', '5', '13', 'C128B', '10', '10', '11', '10', '4', '4', '6', '6', '1', '', '3', '6')");

// Contenu de la table `preidlog_freqactiv`
$freqactiv_insert = "INSERT INTO `preidlog_freqactiv` (`activ_id`, `code_activ`, `nom_activ`, `activ_activ`, `default_activ`, `consult_activ`) VALUES
(1, 'ZERO', '', 0, 0, 0),
(2, 'SEAN', 'Séance', 1, 1, 1),
(3, 'ETUD', 'Etude', 1, 0, 1)";
mysqli_query($bdd,$freqactiv_insert);

// Contenu de la table `preidlog_edtcode`
$edtcode_insert = "INSERT INTO `preidlog_edtcode` (`code_id`, `code`, `nom`, `activ_code`, `default_code`, `bgcolor_code`) VALUES
(1, 'Info-Doc', 'Information-documentation', 1, 1, '#FF9900'),
(2, 'EMI', 'Education aux médias et à l''information', 1, 0, '#99FF00'),
(3, 'IRD', 'Initiation à la recherche documentaire', 1, 0, '#CCFFFF'),
(4, 'EAM', 'Education aux médias', 1, 0, '#FF66FF'),
(5, 'EMC', 'Enseignement moral et civique', 1, 0, '#CC6600'),
(6, 'Hist-Géo', 'Histoire-Géographie', 1, 0, '#FFFF33'),
(7, 'Techno', 'Technologie', 1, 0, '#99CC66'),
(8, 'SVT', 'Science de la vie et de la terre', 1, 0, '#1E7FCB'),
(9, 'P-C', 'Physique-Chimie', 1, 0, '#9900FF'),
(10, 'Fr.', 'Français', 1, 0, '#FF0033'),
(11, 'LVE', 'Langues vivantes étrangères', 1, 0, '#CCCC00'),
(12, 'Maths', 'Mathématiques', 1, 0, '#66CC66'),
(13, 'HDA', 'Histoire des Arts', 1, 0, '#EFD242'),
(14, 'Arts pla.', 'Arts plastiques', 1, 0, '#FFF48D'),
(15, 'AP', 'Accompagnement personnalisé', 1, 0, '#CC99CC'),
(16, 'EPI', 'Enseignement pratique interdisciplinaire', 1, 0, '#E6E697'), 
(17, 'Avenir', 'Parcours Avenir', 1, 0, '#FF6666'),
(18, 'Santé', 'Parcours Santé', 1, 0, '#F4C430')";
mysqli_query($bdd,$edtcode_insert);

// Contenu de la table `preidlog_edtnivcolor`
$edtnivcolor_insert = "INSERT INTO `preidlog_edtnivcolor` (`id`, `niveau`, `bgcolor`) VALUES
('1', '6', '#F5A9A9'),
('2', '5', '#F5D0A9'),
('3', '4', '#E1F5A9'),
('4', '3', '#BCF5A9'),
('5', '2', '#A9F5BC'),
('6', '1', '#A9F5F2'),
('7', 't', '#A9A9F5'),
('8', 'a', '#E2A9F3'),
('9', 'r', '#E6E6E6')";
mysqli_query($bdd,$edtnivcolor_insert);

// Contenu de la table `preidlog_hordemis`
$hordemis_insert = "INSERT INTO `preidlog_hordemis` (`id`, `demijour`, `statut`) VALUES
('1', 'lu_am', '1'),
('8', 'lu_pm', '1'),
('2', 'ma_am', '1'),
('9', 'ma_pm', '1'),
('3', 'me_am', '1'),
('10', 'me_pm', '1'),
('4', 'je_am', '1'),
('11', 'je_pm', '1'),
('5', 've_am', '1'),
('12', 've_pm', '1'),
('6', 'sa_am', '1'),
('13', 'sa_pm', '1'),
('7', 'di_am', '1'),
('14', 'di_pm', '1')";
mysqli_query($bdd,$hordemis_insert);

// Contenu de la table `preidlog_savnotions`
$savnotions_insert = "INSERT INTO `preidlog_savnotions` (`notion_id`, `notion_nom`) VALUES
(1, 'Algorithme'),
(2, 'Analyse de données'),
(3, 'Analyse documentaire'),
(4, 'Annuaire'),
(5, 'Annuaire (web)'),
(6, 'Architecture de l\'information'),
(7, 'Archivage des données'),
(8, 'Auteur'),
(9, 'Base de données'),
(10, 'Besoin d\'information'),
(11, 'Bibliographie'),
(12, 'Bibliothèque'),
(13, 'Bruit documentaire'),
(14, 'Carte conceptuelle ou heuristique'),
(15, 'Catalogue'),
(16, 'Centre de ressources'),
(17, 'Citation'),
(18, 'Classement'),
(19, 'Classification'),
(20, 'Cloud computing'),
(21, 'Code'),
(22, 'Collecte de données'),
(23, 'Collection (édition)'),
(24, 'Descripteur'),
(25, 'Discours (rhétorique, intention)'),
(26, 'Document'),
(27, 'Document hôte'),
(28, 'Document numérique en ligne'),
(29, 'Document primaire'),
(30, 'Document secondaire'),
(31, 'Document tertiaire'),
(32, 'Donnée informationnelle'),
(33, 'Droit de l\'information'),
(34, 'Désinformation'),
(35, 'Economie de l\'information'),
(36, 'Edition'),
(37, 'Editorialisation'),
(38, 'Environnement numérique de travail (ENT)'),
(39, 'Espace informationnel'),
(40, 'Ethique de l\'information'),
(41, 'Evaluation de l\'information'),
(42, 'Exploitation de l\'information'),
(43, 'Hypertexte'),
(44, 'Hébergement (web)'),
(45, 'Identité numérique'),
(46, 'Index'),
(47, 'Indexation'),
(48, 'Indexation automatique'),
(49, 'Indexation documentaire'),
(50, 'Indexation libre (folksonomie)'),
(51, 'Information'),
(52, 'Instabilité documentaire'),
(53, 'Interface de recherche'),
(54, 'Internet'),
(55, 'Intranet'),
(56, 'Journalisme'),
(57, 'Langage documentaire'),
(58, 'Message'),
(59, 'Messagerie (web)'),
(60, 'Mot clé'),
(61, 'Moteur de recherche'),
(62, 'Média'),
(63, 'Médias sociaux (en ligne)'),
(64, 'Médiatisation'),
(65, 'Métadonnée'),
(66, 'Métamoteur'),
(67, 'Méthodologie de la recherche d\'information'),
(68, 'Nature physique de l\'information'),
(69, 'Navigation arborescente'),
(70, 'Notice bibliographique'),
(71, 'Numérisation'),
(72, 'Opérateur de recherche'),
(73, 'Outil de recherche'),
(74, 'Pertinence'),
(75, 'Plagiat'),
(76, 'Portail (en ligne)'),
(77, 'Prise de notes'),
(78, 'Production documentaire'),
(79, 'Publication'),
(80, 'Publicité'),
(81, 'Périodicité'),
(82, 'Recherche d\'information'),
(83, 'Redocumentarisation'),
(84, 'Requête'),
(85, 'Rumeur'),
(86, 'Référence'),
(87, 'Référencement'),
(88, 'Réseau documentaire'),
(89, 'Résumé'),
(90, 'Signalétique'),
(91, 'Silence documentaire'),
(92, 'Site web'),
(93, 'Source'),
(94, 'Source primaire'),
(95, 'Source secondaire'),
(96, 'Structure du document'),
(97, 'Support'),
(98, 'Synthèse documentaire'),
(99, 'Sécurisation des données'),
(100, 'Sérendipité'),
(101, 'Thésaurus'),
(102, 'Trace numérique'),
(103, 'Type d\'information'),
(104, 'Type de document'),
(105, 'Type de source'),
(106, 'Veille informationnelle'),
(107, 'Web sémantique'),
(123, 'Arborescence'),
(124, 'Autorité'),
(125, 'Crédibilité'),
(126, 'Biens communs'),
(127, 'Communs'),
(128, 'Déréférencement'),
(129, 'Equation de recherche'),
(130, 'Fake news'),
(131, 'Folksonomie'),
(132, 'Tag'),
(133, 'Imprimé'),
(134, 'Lemmatisation'),
(135, 'Marché de l\'information'),
(136, 'Numérique'),
(137, 'Répertoire de sites'),
(138, 'Indexation automatisée'),
(139, 'Fiabilité de l\'information'),
(140, 'Propagande'),
(141, 'Design graphique'),
(142, 'Enonciation éditoriale'),
(143, 'Interface utilisateur'),
(144, 'Navigation hypertextuelle'),
(145, 'Résultats de recherche'), 
(146, 'Archives'),
(147, 'Intelligence artificielle')";
mysqli_query($bdd,$savnotions_insert);
?>