<?php
// Recherche de l'encodage
$content = file_get_contents($_FILES['file']['tmp_name']);
$enclist = array(
'UTF-8', 'ASCII',
'ISO-8859-1', 'ISO-8859-2', 'ISO-8859-3', 'ISO-8859-4', 'ISO-8859-5',
'ISO-8859-6', 'ISO-8859-7', 'ISO-8859-8', 'ISO-8859-9', 'ISO-8859-10',
'ISO-8859-13', 'ISO-8859-14', 'ISO-8859-15', 'ISO-8859-16',
'Windows-1251', 'Windows-1252', 'Windows-1254',
);
$encodage = mb_detect_encoding($content,$enclist,TRUE);
if (mb_detect_encoding($content, $enclist, TRUE)==FALSE) {
	echo '<p class="signal">'.PBFILE1.'</p>';
}
// Si l'encodage est gérable
else {
	if('UTF-8' != mb_detect_encoding($content, 'UTF-8', TRUE)) {
		$encoding=1; } else { $encoding=0; }
	// Intégration dans la table ".$prefix."_elevesmaj
	echo '<h1>'.ELEVINSTALL.'</h1>';
	$id = 1;
	$datas_col=0;
	$xml = simplexml_load_string($content);
	$eleves = isset($xml->DONNEES) ? $xml->DONNEES->ELEVES : $xml->ELEVES;
	$structures = [];
	foreach ($xml->DONNEES->STRUCTURES->STRUCTURES_ELEVE as $structure_eleve) {
	    $eleve_strucid = (string)$structure_eleve['ELEVE_ID'];
	    $code_structure = isset($structure_eleve->STRUCTURE->CODE_STRUCTURE) ? 
	                      mysqli_real_escape_string($bdd, $structure_eleve->STRUCTURE->CODE_STRUCTURE) : 
	                      null;
	    $structures[$eleve_strucid] = $code_structure;
	}
	foreach ($eleves->ELEVE as $eleve) {
	    // Récupère le nom de famille et le prénom
	    $eleve_strucid = (string)$eleve['ELEVE_ID'];
	    include('database_datainput_check_xml.php');
		$nom = @mysqli_real_escape_string($bdd, $eleve->NOM_DE_FAMILLE);
    	$prenom = @mysqli_real_escape_string($bdd, $eleve->PRENOM);		
    	$div = isset($structures[$eleve_strucid]) ? $structures[$eleve_strucid] : null;	
		if ($div === null && isset($eleve->CODE_STRUCTURE)) {
	        $div = mysqli_real_escape_string($bdd, $eleve->CODE_STRUCTURE);
	    }	
		if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_user WHERE login = '$att_code'"))>0||$att_code=='reserver') {
			$att_code='';
		}							
		if(mysqli_num_rows(mysqli_query($bdd,"SELECT * FROM ".$prefix."_user WHERE login = '$att_ident'"))>0||$att_ident=='reserver') {
			$att_ident='';
		}
		$att3 = @mysqli_real_escape_string($bdd, $eleve->DATE_NAISS);
		$jour = strtolower($att3);
		$jour = substr("$att3", 0, 2);
		$mois = strtolower($att3);
		$mois = substr("$att3", 3, 2);
		$annee = strtolower($att3);
		$annee = substr("$att3", 6, 4);
		//SEXE
		$att4 = @mysqli_real_escape_string($bdd, $eleve->CODE_SEXE);
		if($att4=="2") { $att4 = "F"; }
		else if($att4=="1") { $att4 = "M"; }
		if(!isset($att_mail)) { $att_mail = ""; }
		if($att_mdp=="") { $att_mdp = @mb_strtolower(substr(strToNoAccent($att1),0,1),'UTF-8').$jour.$mois.$annee; }
		do {
		    $sel = bin2hex(random_bytes(16));
		} while ($sel === '0');
		$mdp_avec_sel = $att_mdp.$sel;
		$hashed_password = hash('sha256', $mdp_avec_sel);					
		if ($div !== null) {
			mysqli_query($bdd,"INSERT INTO ".$prefix."_elevesmaj (eleves_id, nom, prenom, division, naissance, sexe, code, mdp, sel, mail, id_perso) VALUES ('".$id."', '".$nom."', '".$prenom."', '".$div."', '".$annee."-".$mois."-".$jour."', '".$att4."', '".$att_code."', '".$hashed_password."', '".$sel."', '".$att_mail."', '".$att_ident."')");	
			$id++;
		}
	}
}
?>